## quassel 0.8.0

=== CMakeLists.txt ===
# This is the cmake-based build system for Quassel IRC.
#
# You may pass various options to cmake:
# -DWANT_(CORE|QTCLIENT|MONO)=(ON|OFF)
#                        : select binaries to build
# -DWITH_OPENSSL=OFF     : Disable OpenSSL support
# -DWITH_DBUS=OFF        : Disable D-Bus support (dbus notifications)
# -DWITH_WEBKIT=OFF      : Disable WebKit support (link previews)
# -DWITH_PHONON=OFF      : Disable Phonon support (audio notifications)
# -DWITH_LIBINDICATE=OFF : Disable libindicate support (Ayatana notifications)
# -DWITH_KDE=ON          : Enable KDE4 support
# -DWITH_CRYPT=OFF       : Disable encryption support
# -DWITH_OXYGEN=(ON|OFF) : Whether to install Oxygen icons (default: yes, unless KDE > 4.3.0 is present and enabled)
# -DWITH_SYSLOG=OFF      : Disable syslog support
#
# -DEMBED_DATA=ON        : Embed all data files in icons the binary, rather than installing them separately
#
# -DQT=/path/to/qt       : Choose a Qt4 installation to use instead of the system Qt4
# -DSTATIC=ON            : Enable static building of Quassel. Use with care.
# -DDEPLOY=ON            : Mac OS X only. Use only for creating Quassel Packages!
#
# NOTE: You should remove CMakeCache.txt if you plan to change any of these values!

project(QuasselIRC)

include(CheckFunctionExists)
include(CheckIncludeFile)

# cmake 2.6.2 is required for KDE >=4.2 and should be widespread enough now
cmake_minimum_required(VERSION 2.6.2 FATAL_ERROR)

if(COMMAND cmake_policy)
   cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

# Use our own (well, and KDE's) version of some modules
# In particular cmake's own FindQt4 and FindOpenSSL are quite buggy
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
include(QuasselMacros)

# Various options and variables that can be set on the command line
option(WANT_CORE     "Build the core (server) binary"           ON)
option(WANT_QTCLIENT "Build the Qt4 GUI client binary"          ON)
option(WANT_MONO     "Build the monolithic (all-in-one) binary" ON)

option(WITH_OPENSSL  "Enable OpenSSL support if present on the system"	ON)
option(WITH_DBUS     "Enable D-Bus support if present on the system"	ON)
option(WITH_WEBKIT   "Enable WebKit support (for link previews)"	ON)
option(WITH_PHONON   "Enable Phonon support (for audio notifications)"	ON)
option(WITH_LIBINDICATE "Enable Ayatana notification support"           ON)
option(WITH_KDE      "Enable KDE4 integration"				OFF)
option(WITH_CRYPT    "Enable encryption support if present on system"	ON)
option(WITH_SYSLOG   "Use syslog for storing log data"			ON)

# We use icon paths from KDE 4.3.x, which are partially invalid on older and possibly
# even on newer KDE versions. Do not disable this unless you are sure that your Quassel will
# run on a matching KDE version only.
set(WITH_OXYGEN AUTO CACHE STRING "Install Oxygen icons (default is \"AUTO\" to install when KDE 4.3 or later is present")

option(STATIC        "Enable static building (might not be portable)" OFF)

if(APPLE)
  option(DEPLOY        "Mac OS X only! Adds required libs to bundle resources and create a dmg. Note: requires Qt to be built with 10.4u SDK" OFF)
endif(APPLE)

# Default to embedding data in the static case
if(STATIC OR WIN32)
  set(EMBED_DEFAULT ON)
else(STATIC OR WIN32)
  set(EMBED_DEFAULT ON) # should be OFF as soon as everything works
endif(STATIC OR WIN32)

option(EMBED_DATA    "Embed all data files in the binary (rather than installing them separately)"   ${EMBED_DEFAULT})

set(QT "" CACHE STRING "Path to a Qt installation to use instead of the system Qt (e.g. for static builds)")

# Some settings imply others
if(STATIC)
  add_definitions(-DSTATIC)
  set(WITH_KDE OFF CACHE BOOL "Static building with KDE is not supported")
endif(STATIC)

if(WIN32)
  # We don't support separately installed resources yet on Win32
  set(EMBED_DATA ON)
endif(WIN32)

# For static builds, arbitrary extra libs might need to be linked
# Define a comma-separated list here
# e.g. for pgsql, we need -DLINK_EXTRA=pq;crypt
set(LINK_EXTRA "" CACHE STRING "Semicolon-separated list of libraries to be linked")
if(LINK_EXTRA)
  string(REPLACE "," ";" LINK_EXTRA ${LINK_EXTRA})
  link_libraries(${LINK_EXTRA})
endif(LINK_EXTRA)

# Build Type
# We need to make sure it's not empty
# Supported: Release, RelWithDebugInfo, Debug, Debugfull

# On WIN32, only Release seems to work correctly (?)
if(WIN32)
  set(DEFAULT_BUILD_TYPE "Release")
else(WIN32)
  set(DEFAULT_BUILD_TYPE "RelWithDebugInfo")
endif(WIN32)

set(CMAKE_BUILD_TYPE ${DEFAULT_BUILD_TYPE} CACHE STRING "CMake Build Type")
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE ${DEFAULT_BUILD_TYPE} CACHE STRING "CMake Build Type" FORCE)
endif(NOT CMAKE_BUILD_TYPE)

# Enable various flags on gcc
if(CMAKE_COMPILER_IS_GNUCXX)
  # Let's just hope that all gccs support these options and skip the tests...
  # -fno-strict-aliasing is needed apparently for Qt < 4.6
  set(CMAKE_CXX_FLAGS                  "${CMAKE_CXX_FLAGS} -ansi -Wall -Wextra -Wnon-virtual-dtor -fno-strict-aliasing")
  set(CMAKE_CXX_FLAGS_RELEASE          "-O2 ${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS_RELWITHDEBUGINFO "-g -O2 ${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS_DEBUG            "-g -ggdb -fno-reorder-blocks -fno-schedule-insns -fno-inline ${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS_DEBUGFULL        "-g3 ${CMAKE_CXX_FLAGS_DEBUG}")
endif(CMAKE_COMPILER_IS_GNUCXX)

string(TOUPPER ${CMAKE_BUILD_TYPE} upper_build_type)
if(upper_build_type STREQUAL "RELEASE" OR upper_build_type STREQUAL "RELWITHDEBUGINFO")
  add_definitions(-DNDEBUG -DQT_NO_DEBUG)
else(upper_build_type STREQUAL "RELEASE" OR upper_build_type STREQUAL "RELWITHDEBUGINFO")
  set(DEBUG 1)
endif(upper_build_type STREQUAL "RELEASE" OR upper_build_type STREQUAL "RELWITHDEBUGINFO")

if(APPLE AND DEPLOY)
  set(CMAKE_OSX_ARCHITECTURES "i386;ppc")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.4")
  set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.4u.sdk/")
  add_definitions(-DMAC_10_4_SDK)
endif(APPLE AND DEPLOY)

# Simplify checks
if(WANT_MONO OR WANT_QTCLIENT)
  set(BUILD_GUI true)
endif(WANT_MONO OR WANT_QTCLIENT)
if(WANT_MONO OR WANT_CORE)
  set(BUILD_CORE true)
endif(WANT_MONO OR WANT_CORE)

# Dependencies
##############

# GUI stuff needs some new features
if(BUILD_GUI)
  set(QT_MIN_VERSION "4.6.0")
else(BUILD_GUI)
  set(QT_MIN_VERSION "4.4.0")
endif(BUILD_GUI)

# Execinfo is needed for generating backtraces
find_package(ExecInfo)
if(EXECINFO_FOUND)
  add_definitions(-DHAVE_EXECINFO)
  include_directories(${EXECINFO_INCLUDES})
  link_libraries(${EXECINFO_LIBRARIES})
endif(EXECINFO_FOUND)

# Select a Qt installation here, if you don't want to use system Qt
if(QT)
  # FindQt4 will look for the qmake binary in $PATH, so we just prepend the Qt dir
  set(ENV{PATH} ${QT}/bin:$ENV{PATH})
endif(QT)

# Now that we have the correct $PATH, lets find Qt!
find_package(Qt4 REQUIRED)

set(QT_DONT_USE_QTGUI 1)
include(${QT_USE_FILE})
include_directories(${QT_INCLUDES})

# PkgConfig isn't strictly required.
# However, some optional deps might not be found if it's not present, so warn!
find_package(PkgConfig)
if(NOT PKG_CONFIG_FOUND)
  message(STATUS "WARNING: PkgConfig not available! Some dependencies for optional features might not be found.")
  message(STATUS "         Affected features might include encryption support, DBus menus and Ayatana notifications.")
endif(NOT PKG_CONFIG_FOUND)

# Setup OpenSSL
# We don't link to or include OpenSSL ourselves, but use exclusively the Qt API.
# Thus, we simply check if OpenSSL support is present in Qt's config and enable our
# own SSL stuff in this case. Qt should care for adding what it needs itself.
if(WITH_OPENSSL)
  if(QT_QCONFIG MATCHES "openssl")
    message(STATUS "Found OpenSSL support in Qt, enabling SSL")
    add_definitions(-DHAVE_SSL)
    set(HAVE_SSL true)
  else(QT_QCONFIG MATCHES "openssl")
    message(STATUS "No OpenSSL support found in Qt, disabling SSL")
    add_definitions(-DQT_NO_OPENSSL)
  endif(QT_QCONFIG MATCHES "openssl")
else(WITH_OPENSSL)
  message(STATUS "Not enabling OpenSSL support")
endif(WITH_OPENSSL)

# Check for GUI specific stuff
if(BUILD_GUI)

  # Setup D-Bus support
  if(WITH_DBUS)
    if(QT_QTDBUS_FOUND)
      message(STATUS "Found QtDBus, enabling D-Bus support")
      add_definitions(-DHAVE_DBUS)
      set(CLIENT_QT4_VARS ${CLIENT_QT4_VARS} DBUS)
      set(CLIENT_COMPILE_FLAGS "${CLIENT_COMPILE_FLAGS} -DQT_DBUS_LIB")
      set(HAVE_DBUS true)

      # check if we have dbusmenu as well
      find_package(DBusMenuQt)
      if(DBUSMENUQT_FOUND)
        message(STATUS "Enabling support for exporting the tray menu via D-Bus")
        add_definitions(-DHAVE_DBUSMENU)
        include_directories(${DBUSMENUQT_INCLUDE_DIR})
        set(CLIENT_LIBRARIES ${CLIENT_LIBRARIES} ${DBUSMENUQT_LIBRARIES})
        set(CLIENT_COMPILE_FLAGS "${CLIENT_COMPILE_FLAGS} ${DBUSMENUQT_DEFINITIONS}")
      else(DBUSMENUQT_FOUND)
        message(STATUS "Disabling support for exporting the tray menu via D-Bus")
      endif(DBUSMENUQT_FOUND)

    else(QT_QTDBUS_FOUND)
      message(STATUS "QtDBus not found, disabling D-Bus support")
    endif(QT_QTDBUS_FOUND)
  else(WITH_DBUS)
    message(STATUS "Not enabling D-Bus support")
  endif(WITH_DBUS)

  # Setup QtWebKit support
  if(WITH_WEBKIT)
    if(QT_QTWEBKIT_FOUND)
      message(STATUS "Found QtWebKit, enabling WebKit support")
      add_definitions(-DHAVE_WEBKIT)
      set(CLIENT_QT4_VARS ${CLIENT_QT4_VARS} WEBKIT XMLPATTERNS)
      set(CLIENT_COMPILE_FLAGS "${CLIENT_COMPILE_FLAGS} -DQT_WEBKIT_LIB -DQT_XMLPATTERNS_LIB")
      set(HAVE_WEBKIT true)
    else(QT_QTWEBKIT_FOUND)
      message(STATUS "QtWebKit not found, disabling WebKit support")
    endif(QT_QTWEBKIT_FOUND)
  else(WITH_WEBKIT)
    message(STATUS "Not enabling WebKit support")
  endif(WITH_WEBKIT)

  # Setup KDE4 support
  if(WITH_KDE)
    find_package(KDE4)
    if(KDE4_FOUND)
      message(STATUS "Enabling KDE4 integration")
      include_directories(${KDE4_INCLUDES})
      add_definitions(-DHAVE_KDE ${KDE4_DEFINITIONS})
      set(HAVE_KDE 1)
      set(CLIENT_LIBRARIES ${CLIENT_LIBRARIES} ${KDE4_KDECORE_LIBS} ${KDE4_KDEUI_LIBRARY} ${KDE4_SOLID_LIBS} knotifyconfig)
      # We always use external icons for KDE4 support, since we use its iconloader rather than our own
      set(EMBED_DATA OFF)
    else(KDE4_FOUND)
      message(STATUS "KDE4 not found, disabling KDE integration")
    endif(KDE4_FOUND)
  else(WITH_KDE)
    message(STATUS "Not enabling KDE4 integration")
  endif(WITH_KDE)

  # Setup Phonon support - we only need this if we don't have or want KDE4
  if(NOT HAVE_KDE)
    if(WITH_PHONON)
      find_package(Phonon)
      if(PHONON_FOUND)
        message(STATUS "Enabling Phonon support")
        add_definitions(-DHAVE_PHONON)
        include_directories(${PHONON_INCLUDES})
        set(CLIENT_LIBRARIES ${CLIENT_LIBRARIES} ${PHONON_LIBS})
        set(HAVE_PHONON true)
      else(PHONON_FOUND)
        message(STATUS "Phonon not found, disabling audio notifications")
      endif(PHONON_FOUND)
    else(WITH_PHONON)
      message(STATUS "Not enabling Phonon support")
    endif(WITH_PHONON)
  endif(NOT HAVE_KDE)

  # Setup libindicate-qt support
  if(WITH_LIBINDICATE)
    pkg_check_modules(INDICATEQT QUIET indicate-qt>=0.2.1)
    if(INDICATEQT_FOUND)
      message(STATUS "Enabling Ayatana notification support")
      set(HAVE_INDICATEQT true)
      add_definitions(-DHAVE_INDICATEQT)
      link_directories(${INDICATEQT_LIBRARY_DIRS})
      set(CLIENT_LIBRARIES ${CLIENT_LIBRARIES} ${INDICATEQT_LIBRARIES})
    else(INDICATEQT_FOUND)
      message(STATUS "Disabling Ayatana notification support")
    endif(INDICATEQT_FOUND)
  else(WITH_LIBINDICATE)
    message(STATUS "Not enabling Ayatana notification support")
    # We don't want to link against it even if another package has found it
    set(INDICATEQT_LIBRARIES "")
  endif(WITH_LIBINDICATE)

endif(BUILD_GUI)

# Core-only deps
if(BUILD_CORE)

  # Setup encryption support

=== data/CMakeLists.txt ===
# cmake-2.6.2 can't handle nested conditions
# if((UNIX AND NOT APPLE) OR HAVE_KDE)
if(HAVE_KDE OR UNIX)
 if(HAVE_KDE OR NOT APPLE)
  if(WANT_QTCLIENT)
    install(FILES quasselclient.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
  endif(WANT_QTCLIENT)

  if(WANT_MONO)
    install(FILES quassel.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
  endif(WANT_MONO)

  if(WANT_MONO OR WANT_QTCLIENT)
    if(HAVE_KDE)
      install(FILES quassel.notifyrc DESTINATION ${DATA_INSTALL_DIR}/quassel)
    endif(HAVE_KDE)
  endif(WANT_MONO OR WANT_QTCLIENT)

# endif((UNIX AND NOT APPLE) OR HAVE_KDE)
 endif(HAVE_KDE OR NOT APPLE)
endif(HAVE_KDE OR UNIX)

if(WANT_MONO OR WANT_QTCLIENT)
  if(EMBED_DATA)
    set(CLIENT_RCS ${CLIENT_RCS} ../data/data.qrc PARENT_SCOPE)
  else(EMBED_DATA)
    install(FILES networks.ini DESTINATION ${DATA_INSTALL_DIR}/quassel)
    install(DIRECTORY stylesheets DESTINATION ${DATA_INSTALL_DIR}/quassel)
  endif(EMBED_DATA)

  if(NOT WIN32)
    install(DIRECTORY scripts DESTINATION ${DATA_INSTALL_DIR}/quassel USE_SOURCE_PERMISSIONS)
  endif(NOT WIN32)

endif(WANT_MONO OR WANT_QTCLIENT)

=== src/CMakeLists.txt ===
# Builds the three main targets

add_subdirectory(common)
include_directories(BEFORE common)
if(BUILD_CORE)
  add_subdirectory(core)
  include_directories(BEFORE core)
endif(BUILD_CORE)
if(BUILD_GUI)
  add_subdirectory(client)
  add_subdirectory(uisupport)
  add_subdirectory(qtui)
  include_directories(BEFORE client)
  include_directories(BEFORE uisupport)
  include_directories(BEFORE qtui)

  if(STATIC)
    link_directories(${QT_PLUGINS_DIR}/imageformats)
    set(CLIENT_LIBS ${CLIENT_LIBS} qjpeg qgif)
  endif(STATIC)
endif(BUILD_GUI)

include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR}) # for version.gen

# Add resources. Can't be done in other subdirs apparently.
# Note that these variables need to contain paths relative to src/ (this dir)
qt4_add_resources(CLIENT_DEPS ${CLIENT_RCS})
qt4_add_resources(CORE_DEPS ${CORE_RCS})
qt4_add_resources(COMMON_DEPS ${COMMON_RCS})

if(WANT_CORE)
  setup_qt4_variables(NETWORK SCRIPT SQL)
  add_executable(quasselcore common/main.cpp ${COMMON_DEPS} ${CORE_DEPS})
  add_dependencies(quasselcore po genversion_run)
  set_target_properties(quasselcore PROPERTIES
                                    COMPILE_FLAGS "-DQT_NETWORK_LIB -DQT_SCRIPT_LIB -DQT_SQL_LIB -DBUILD_CORE"
                                    OUTPUT_NAME ../quasselcore)
  target_link_libraries(quasselcore mod_core mod_common
                                    ${QUASSEL_QT_LIBRARIES} ${QUASSEL_SSL_LIBRARIES})
  install(TARGETS quasselcore RUNTIME DESTINATION ${BIN_INSTALL_DIR})
endif(WANT_CORE)

if(WANT_QTCLIENT)
  setup_qt4_variables(GUI NETWORK ${CLIENT_QT4_VARS})
  add_executable(quasselclient WIN32 common/main.cpp ${COMMON_DEPS} ${CLIENT_DEPS})
  add_dependencies(quasselclient po genversion_run)
  set_target_properties(quasselclient PROPERTIES
                                      COMPILE_FLAGS "-DQT_GUI_LIB -DQT_NETWORK_LIB ${CLIENT_COMPILE_FLAGS} -DBUILD_QTUI"
                                      OUTPUT_NAME ../quasselclient)
  target_link_libraries(quasselclient ${LINK_KDE} mod_qtui mod_uisupport mod_client mod_common ${CLIENT_LIBS}
                                      ${QUASSEL_QT_LIBRARIES} ${QUASSEL_SSL_LIBRARIES} ${CLIENT_LIBRARIES})
  install(TARGETS quasselclient RUNTIME DESTINATION ${BIN_INSTALL_DIR})
endif(WANT_QTCLIENT)

if(WANT_MONO)
  setup_qt4_variables(GUI NETWORK SCRIPT SQL ${CLIENT_QT4_VARS})
  qt4_wrap_cpp(MOC qtui/monoapplication.h)
  add_executable(quassel WIN32 common/main.cpp qtui/monoapplication.cpp ${MOC} ${COMMON_DEPS} ${CLIENT_DEPS} ${CORE_DEPS})
  add_dependencies(quassel po genversion_run)
  set_target_properties(quassel PROPERTIES
                                COMPILE_FLAGS "-DQT_GUI_LIB -DQT_NETWORK_LIB -DQT_SCRIPT_LIB -DQT_SQL_LIB ${CLIENT_COMPILE_FLAGS} -DBUILD_MONO"
                                OUTPUT_NAME ../quassel)
  target_link_libraries(quassel mod_qtui mod_uisupport mod_client mod_core mod_common ${CLIENT_LIBS}
                                ${QUASSEL_QT_LIBRARIES} ${QUASSEL_SSL_LIBRARIES} ${CLIENT_LIBRARIES})
  install(TARGETS quassel RUNTIME DESTINATION ${BIN_INSTALL_DIR})
endif(WANT_MONO)

# Build bundles for MacOSX
if(APPLE)
  add_custom_command(TARGET quasselclient POST_BUILD
                     COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makebundle.py
                             ${CMAKE_SOURCE_DIR} "Quassel Client" ../quasselclient)
  add_custom_command(TARGET quassel POST_BUILD
                     COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makebundle.py
                             ${CMAKE_SOURCE_DIR} "Quassel" ../quassel)
  if(DEPLOY)
    add_custom_command(TARGET quasselclient POST_BUILD
                       COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Client ..)
    add_custom_command(TARGET quasselcore POST_BUILD
                       COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Core ..)
  endif(DEPLOY)
endif(APPLE)

=== src/common/CMakeLists.txt ===
# Builds the common module
set(QT_DONT_USE_QTGUI 1)
set(QT_USE_QTNETWORK 1)
include(${QT_USE_FILE})

set(SOURCES
    aliasmanager.cpp
    backlogmanager.cpp
    basichandler.cpp
    bufferinfo.cpp
    buffersyncer.cpp
    bufferviewconfig.cpp
    bufferviewmanager.cpp
    cliparser.cpp
    ctcpevent.cpp
    event.cpp
    eventmanager.cpp
    identity.cpp
    ignorelistmanager.cpp
    ircchannel.cpp
    ircevent.cpp
    irclisthelper.cpp
    ircuser.cpp
    logger.cpp
    message.cpp
    messageevent.cpp
    network.cpp
    networkconfig.cpp
    networkevent.cpp
    quassel.cpp
    settings.cpp
    signalproxy.cpp
    syncableobject.cpp
    util.cpp)

set(MOC_HDRS
    aliasmanager.h
    backlogmanager.h
    basichandler.h
    buffersyncer.h
    bufferviewconfig.h
    bufferviewmanager.h
    coreinfo.h
    eventmanager.h
    identity.h
    ignorelistmanager.h
    ircchannel.h
    irclisthelper.h
    ircuser.h
    network.h
    networkconfig.h
    settings.h
    signalproxy.h
    syncableobject.h)

set(HEADERS ${MOC_HDRS}
    abstractcliparser.h
    bufferinfo.h
    cliparser.h
    ctcpevent.h
    event.h
    ircevent.h
    networkevent.h
    messageevent.h
    logger.h
    message.h
    types.h
    util.h)

if(APPLE)
  set(SOURCES ${SOURCES} mac_utils.cpp)
  set(HEADERS ${HEADERS} mac_utils.h)
endif(APPLE)

if(CMAKE_HOST_WIN32)
    set(SOURCES ${SOURCES} logbacktrace_win.cpp)
endif(CMAKE_HOST_WIN32)
if(CMAKE_HOST_UNIX)
    set(SOURCES ${SOURCES} logbacktrace_unix.cpp)
endif(CMAKE_HOST_UNIX)

qt4_wrap_cpp(MOC ${MOC_HDRS})

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR})  # for version.inc and version.gen
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES version.gen)

add_library(mod_common STATIC ${SOURCES} ${MOC})

if(APPLE)
  target_link_libraries(mod_common "-framework CoreServices" "-framework CoreFoundation")
endif(APPLE)

target_link_libraries(mod_common ${CMAKE_DL_LIBS})

=== src/core/CMakeLists.txt ===
# Builds the core module

set(QT_DONT_USE_QTGUI 1)
set(QT_USE_QTNETWORK 1)
set(QT_USE_QTSQL 1)
set(QT_USE_QTSCRIPT 1)
include(${QT_USE_FILE})

set(SOURCES
    abstractsqlstorage.cpp
    core.cpp
    corealiasmanager.cpp
    coreapplication.cpp
    corebacklogmanager.cpp
    corebasichandler.cpp
    corebuffersyncer.cpp
    corebufferviewconfig.cpp
    corebufferviewmanager.cpp
    corecoreinfo.cpp
    coreidentity.cpp
    coreignorelistmanager.cpp
    coreircchannel.cpp
    coreirclisthelper.cpp
    coreircuser.cpp
    corenetwork.cpp
    corenetworkconfig.cpp
    coresession.cpp
    coresessioneventprocessor.cpp
    coresettings.cpp
    coreuserinputhandler.cpp
    coreusersettings.cpp
    ctcpparser.cpp
    eventstringifier.cpp
    ircparser.cpp
    netsplit.cpp
    oidentdconfiggenerator.cpp
    postgresqlstorage.cpp
    sessionthread.cpp
    sqlitestorage.cpp
    storage.cpp)

set(MOC_HDRS
    abstractsqlstorage.h
    core.h
    corealiasmanager.h
    coreapplication.h
    corebacklogmanager.h
    corebasichandler.h
    corebuffersyncer.h
    corebufferviewconfig.h
    corebufferviewmanager.h
    corecoreinfo.h
    coreidentity.h
    coreignorelistmanager.h
    coreircchannel.h
    coreirclisthelper.h
    coreircuser.h
    corenetwork.h
    corenetworkconfig.h
    coresession.h
    coresessioneventprocessor.h
    coreuserinputhandler.h
    ctcpparser.h
    eventstringifier.h
    ircparser.h
    netsplit.h
    oidentdconfiggenerator.h
    postgresqlstorage.h
    sqlitestorage.h
    storage.h
    sessionthread.h)

set(HEADERS
    coresettings.h
    coreusersettings.h)

if(HAVE_SSL)
  set(SOURCES ${SOURCES} sslserver.cpp)
  set(MOC_HDRS ${MOC_HDRS} sslserver.h)
  include_directories(${OPENSSL_INCLUDE_DIR})
endif(HAVE_SSL)

if(HAVE_QCA2)
  set(SOURCES ${SOURCES} cipher.cpp)
  set(HEADERS ${HEADERS} cipher.h)
  include_directories(${QCA2_INCLUDE_DIR})
endif(HAVE_QCA2)

qt4_wrap_cpp(MOC ${MOC_HDRS})
set(CORE_RCS ${CORE_RCS} core/sql.qrc PARENT_SCOPE)

include_directories(${CMAKE_SOURCE_DIR}/src/common)

add_library(mod_core STATIC ${SOURCES} ${MOC} ${HEADERS})
add_dependencies(mod_core mod_common)

if(HAVE_QCA2)
  target_link_libraries(mod_core ${QCA2_LIBRARIES})
endif(HAVE_QCA2)

=== src/uisupport/CMakeLists.txt ===
# Builds the uisupport module

set(QT_DONT_USE_QTGUI 0)
set(QT_USE_QTNETWORK 1)
include(${QT_USE_FILE})

if (QCA2_FOUND)
  include_directories(${QCA2_INCLUDE_DIR})
endif (QCA2_FOUND)

set(SOURCES
    abstractbuffercontainer.cpp
    abstractitemview.cpp
    action.cpp
    actioncollection.cpp
    bufferhotlistfilter.cpp
    bufferview.cpp
    bufferviewfilter.cpp
    bufferviewoverlayfilter.cpp
    clearablelineedit.cpp
    clickable.cpp
    clickablelabel.cpp
    colorbutton.cpp
    contextmenuactionprovider.cpp
    flatproxymodel.cpp
    fontselector.cpp
    graphicalui.cpp
    icon.cpp
    iconloader.cpp
    multilineedit.cpp
    networkmodelcontroller.cpp
    nickview.cpp
    nickviewfilter.cpp
    qssparser.cpp
    resizingstackedwidget.cpp
    settingspage.cpp
    styledlabel.cpp
    tabcompleter.cpp
    toolbaractionprovider.cpp
    uisettings.cpp
    uistyle.cpp
   )

set(MOC_HDRS
    abstractbuffercontainer.h
    abstractitemview.h
    abstractnotificationbackend.h
    action.h
    actioncollection.h
    bufferhotlistfilter.h
    bufferview.h
    bufferviewfilter.h
    bufferviewoverlayfilter.h
    clearablelineedit.h
    clickablelabel.h
    colorbutton.h
    contextmenuactionprovider.h
    flatproxymodel.h
    fontselector.h
    graphicalui.h
    iconloader.h
    multilineedit.h
    networkmodelcontroller.h
    nickview.h
    nickviewfilter.h
    resizingstackedwidget.h
    settingspage.h
    styledlabel.h
    tabcompleter.h
    toolbaractionprovider.h
    uistyle.h
   )

set(HEADERS
    clickable.h
    icon.h
    qssparser.h
    uisettings.h
   )

if(HAVE_KDE)
    set(SOURCES ${SOURCES} kcmdlinewrapper.cpp)
    set(HEADERS ${HEADERS} kcmdlinewrapper.h)
endif(HAVE_KDE)

qt4_wrap_cpp(MOC ${MOC_HDRS})

include_directories(${CMAKE_SOURCE_DIR}/src/common
                    ${CMAKE_SOURCE_DIR}/src/client)

add_library(mod_uisupport STATIC ${SOURCES} ${MOC} ${HEADERS})
add_dependencies(mod_uisupport mod_common mod_client)

=== debian/changelog ===
quassel (0.8.0-1+deb7u3) wheezy-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Add CVE-2014-8483.patch patch.
    CVE-2014-8483: out-of-bounds read on a heap-allocated array.
    (Closes: #766962)

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 28 Oct 2014 17:10:53 +0100

quassel (0.8.0-1+deb7u2) wheezy; urgency=medium

  * Fixing security issue where quassel core certificate is 
    readable by all local users
    - Change permissions of /var/lib/quassel/quasselCert.pem
    - Add debian/NEWS to notify the admin to change the certificate

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Thu, 03 Jul 2014 14:42:18 +0200

quassel (0.8.0-1+deb7u1) wheezy; urgency=medium

  * Fix CVE-2013-6404: clients can access backlogs belonging to other users
    - Backport upstream commit in CVE-2013-6404.patch

 -- Felix Geyer <fgeyer@debian.org>  Sun, 09 Mar 2014 13:41:50 +0100

quassel (0.8.0-1) unstable; urgency=low

  * New upstream release
  * Debian Policy to 3.9.3

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Wed, 25 Apr 2012 00:02:51 +0200

quassel (0.7.3-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "fails to upgrade from squeeze": test for existence of to-be-moved
    file in quassel-core.preinst; and use -p for mkdir to avoid errors when
    the directory exists, like after failed upgrades.
    (Closes: #655844)

 -- gregor herrmann <gregoa@debian.org>  Tue, 10 Apr 2012 19:02:42 +0200

quassel (0.7.3-2) unstable; urgency=medium

  * Change Build-Depends of the package from libpng12-dev to libpng-dev.
    (Closes: #662486)

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Mon, 05 Mar 2012 09:27:50 +0100

quassel (0.7.3-1) unstable; urgency=medium

  * New upstream release
  * Translation update
  * Fixing security issue: ctcp DoS (Closes: #640960)

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Fri, 09 Sep 2011 19:00:55 +0000

quassel (0.7.2-2) unstable; urgency=low

  * DATADIR set to new location /var/lib/ (Closes: #629507)

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Tue, 07 Jun 2011 19:01:51 +0000

quassel (0.7.2-1) unstable; urgency=low

  * New upstream release (Closes: #629393)
  * Clients no longer recommend quassel-core (Closes: #622904)
  * Debian Policy to 3.9.2
  * quassel-core.preinst added - taken from Ubuntu (Closes: #612042)
    Thanks to Scott Kitterman <scott@kitterman.com> 

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Mon, 06 Jun 2011 20:40:24 +0200

quassel (0.7.1-4) unstable; urgency=low

  * 0.7.1-3 lost the kfreebsd patch of 0.7.1-2

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Thu, 14 Apr 2011 20:08:27 +0200

quassel (0.7.1-3) unstable; urgency=low

  * Build-dependency qt4-dev-tools added (Closes: #613599)
  * Build-dependency libqtwebkit-dev added (Closes: #622273)
  * Build-dependency libdbusmenu-qt-dev added
  * Build-dependency libindicate-qt-dev added

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Tue, 12 Apr 2011 22:40:46 +0200

quassel (0.7.1-2) unstable; urgency=low

  * Patch added to fix kfreebsd builds (Closes: #620542)

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Mon, 11 Apr 2011 21:44:34 +0200

quassel (0.7.1-1.1) unstable; urgency=low

  * Non-maintainer upload with maintainer permission.
  * Do not hardcode kdelibs5 and kdebase-runtime in quassel-client-kde4 and
    quassel-kde4 Depends (Closes: #616026). kdelibs5 has been deprecated and
    will be removed soon while kdebase-runtime is added via shlibs as needed.

 -- Modestas Vainius <modax@debian.org>  Wed, 30 Mar 2011 18:59:12 +0300

quassel (0.7.1-1) unstable; urgency=low

  * New upstream release

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Tue, 21 Sep 2010 19:59:07 +0200

quassel (0.7.0-1) unstable; urgency=low

  * New upstream release

 -- Thomas Mueller <thomas.mueller@tmit.eu>  Sat, 18 Sep 2010 19:19:40 +0200 
 

=== debian/control ===
Source: quassel
Section: net
Priority: optional
Maintainer: Thomas Mueller <thomas.mueller@tmit.eu>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.0.50~), libqt4-dev, cmake, libfontconfig1-dev, libfreetype6-dev, libpng-dev, libsm-dev, libice-dev, libxi-dev, libxrandr-dev, libxrender-dev, zlib1g-dev, libssl-dev, libdbus-1-dev, pkg-kde-tools, kdelibs5-dev, libqca2-dev, qt4-dev-tools, libqtwebkit-dev, libindicate-qt-dev, libdbusmenu-qt-dev
Homepage: http://www.quassel-irc.org
Standards-Version: 3.9.3

Package: quassel-core
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, libqt4-sql-sqlite, lsb-base (>= 3.2-14), openssl
Description: distributed IRC client - core component
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the core component.

Package: quassel-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, quassel-data (= ${source:Version}), dbus-x11, phonon, gawk
Conflicts: quassel (<< 0.3.1-1), quassel-client-kde4
Replaces: quassel (<< 0.3.1-1)
Description: distributed IRC client - Qt-based client component
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the client component.

Package: quassel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt4-sql-sqlite, quassel-data (=${source:Version}), dbus-x11, phonon, gawk
Conflicts: quassel-kde4
Description: distributed IRC client - Qt-based monolithic core+client
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides the monolithic client. It contains both core and
 client and can be used like a traditional IRC client, without requiring an
 external core.

Package: quassel-data
Architecture: all
Depends: ${misc:Depends}
Conflicts: quassel (<< 0.3.1-1), quassel-data-kde4
Replaces: quassel (<< 0.3.1-1)
Description: distributed IRC client - shared data (Qt version)
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides files used by the Qt-based Quassel client
 packages.

Package: quassel-client-kde4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, quassel-data-kde4 (=${source:Version}), dbus-x11, gawk
Conflicts: quassel-client
Description: distributed IRC client - KDE-based client
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the client component compiled with KDE4 support.

Package: quassel-kde4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt4-sql-sqlite, quassel-data-kde4 (= ${source:Version}), dbus-x11, gawk
Conflicts: quassel
Description: distributed IRC client - KDE-based monolithic core+client
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides the monolithic client compiled with KDE4 support.
 It contains both core and client and can be used like a traditional IRC
 client, without requiring an external core.

Package: quassel-data-kde4
Architecture: all
Depends: ${misc:Depends}
Conflicts: quassel (<< 0.3.1-1), quassel-data
Replaces: quassel (<< 0.3.1-1)
Description: distributed IRC client - shared data (KDE4 version)
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides files used by the KDE4-based Quassel client
 packages.

=== debian/watch ===
version=3

http://quassel-irc.org/downloads \
  /pub/quassel-(.*)\.tar\.bz2 debian uupdate

## quassel 0.9.0

=== debian/changelog ===
quassel (0.9.0-0ubuntu1) raring; urgency=low

  * New upstream release

 -- Scott Kitterman <scott@kitterman.com>  Tue, 16 Apr 2013 21:28:37 -0400

quassel (0.9~rc1-0ubuntu1) raring; urgency=low

  * New upstream release

 -- Scott Kitterman <scott@kitterman.com>  Tue, 09 Apr 2013 19:34:42 -0400

quassel (0.9~beta1-0ubuntu2) raring; urgency=low

  * Fix mess with icons due to obsolete package naming and lack of sufficient
    hicolor icons:
    - Drop quassel-data depends on no longer existing kde-icons-oxygen |
      hicolor-icon-theme
    - Add Recommends: oxygen-icon-theme for quassel/quassel-core
    - Change build flag for Qt only build to include subset of oxygen icons
      shipped with quassel
    - Add new binary, quassel-qt4-data, to hold Qt unique icons and have the
      Qt only packages Recommend it

 -- Scott Kitterman <scott@kitterman.com>  Fri, 15 Mar 2013 15:32:25 -0400

quassel (0.9~beta1-0ubuntu1) raring; urgency=low

  * New upstream beta release
    - Remove debian/patches/0001-Support-intermediate-CA-certificates.patch,
      incorporated upstream
    - Remove 0002-Allow-the-core-to-use-expired-certificates.patch,
      incorporated upstream
    - Update kubuntu_02_enable_message_indicator.diff for 0.9

 -- Scott Kitterman <scott@kitterman.com>  Wed, 06 Mar 2013 15:07:41 -0500

quassel (0.8.0-0ubuntu2) quantal; urgency=low

  * Add libqtwebkit-dev to build deps to enable link previews 

 -- Rohan Garg <rohangarg@kubuntu.org>  Sun, 26 Aug 2012 13:21:16 +0530

quassel (0.8.0-0ubuntu1) precise; urgency=low

  * New upstream release
  * Add debian/patches/0001-Support-intermediate-CA-certificates.patch and
    0002-Allow-the-core-to-use-expired-certificates.patch from Felix Geyer to
    correct issues with SSL integration

 -- Scott Kitterman <scott@kitterman.com>  Tue, 20 Mar 2012 18:21:56 -0400

quassel (0.8~rc1-0ubuntu2) precise; urgency=low

  * Build-depend on dh-apparmor. (LP: #948481)
  * Append $CPPFLAGS to $CXXFLAGS.
  * Use pkg-info.mk instead of parsing the upstream version manually.
  * Drop ancient Conflicts and Replaces.
  * Bump Standards-Version to 3.9.3, no changes needed.
  * Switch AppArmor profile to enforce mode.
  * Don't pass -DCMAKE_BUILD_TYPE=Debugfull to cmake anymore. We want the
    default build type RelWithDebugInfo.
  * Add an ufw application profile.
  * Use dh_install --sourcedir instead of specifying absolute paths in the
    install files.

 -- Felix Geyer <debfx@ubuntu.com>  Sun, 11 Mar 2012 23:00:26 +0100

quassel (0.8~rc1-0ubuntu1) precise; urgency=low

  * New update release candidate

 -- Scott Kitterman <scott@kitterman.com>  Tue, 21 Feb 2012 17:27:22 -0500

quassel (0.8~beta1-0ubuntu1) precise; urgency=low

  * New upstream beta release
    - Update quasselcore man page for new oidentd option 

 -- Scott Kitterman <scott@kitterman.com>  Tue, 14 Feb 2012 18:38:55 -0500

quassel (0.7.3-0ubuntu4) precise; urgency=low

  * Enable hardening options pie and bindnow.
  * Drop the quasselcore-makecert manpage since we no longer provide
    that script.
  * Add an AppArmor profile for quasselcore in complain mode.

 -- Felix Geyer <debfx@ubuntu.com>  Fri, 16 Dec 2011 11:35:10 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

CMAKE_OPTIONS = -DWANT_MONO=ON -DEMBED_DATA=OFF

DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+pie,+bindnow
include /usr/share/dpkg/buildflags.mk
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --buildsystem=cmake --with=kde --parallel

override_dh_clean:
	dh_clean
	rm -rf debian/build-qt4 debian/tmp-qt4

override_dh_auto_configure:
	dh_auto_configure -Skde -- -DWITH_KDE=ON $(CMAKE_OPTIONS)
	dh_auto_configure -Bdebian/build-qt4 -- -DWITH_KDE=OFF -DWANT_CORE=OFF -DWITH_OXYGEN=ON $(CMAKE_OPTIONS)

override_dh_auto_build:
	dh_auto_build -Skde
	dh_auto_build -Bdebian/build-qt4
	pod2man --section=1 --release=$(DEB_VERSION_UPSTREAM) --center "" debian/mans/quassel.pod > quassel.1
	pod2man --section=1 --release=$(DEB_VERSION_UPSTREAM) --center "" debian/mans/quasselcore.pod > quasselcore.1
	pod2man --section=1 --release=$(DEB_VERSION_UPSTREAM) --center "" debian/mans/quasselclient.pod > quasselclient.1

override_dh_auto_install:
	dh_auto_install -Skde
	dh_auto_install -Bdebian/build-qt4 --destdir=$(CURDIR)/debian/tmp-qt4

override_dh_install:
	dh_install -pquassel-qt4 -pquassel-client-qt4 -pquassel-qt4-data --sourcedir=debian/tmp-qt4
	dh_install --remaining-packages -Xusr/share/kde4/apps/quassel/icons/oxygen/scalable --list-missing
	install -o root -g root -m 644 debian/quassel-core.ufw.profile debian/quassel-core/etc/ufw/applications.d/quasselcore

override_dh_installinit:
	dh_apparmor -pquassel-core --profile-name=usr.bin.quasselcore
	dh_installinit -r --error-handler=exit --name=quasselcore

override_dh_strip:
	# only strip the KDE stuff to the dbg package
	dh_strip -Nquassel-qt4 -Nquassel-client-qt4 --dbg-package=quassel-dbg
	dh_strip --remaining-packages

## quassel 0.9.1

=== debian/changelog ===
quassel (0.9.1-0ubuntu1) saucy; urgency=low

  * New upstream release

 -- Scott Kitterman <scott@kitterman.com>  Fri, 11 Oct 2013 00:06:18 -0400
